<?php
###############################################
# PUArcade High Scores Tab 	           	      #
# for Community Builder  					  #
# Copyright (C) 2007  by Pragmatic Utopia     #
# Homepage   : www.pragmaticutopia.com        #
# Email      : puarcade@pragmaticutopia.com   #
# Version    : 2.1.0 modded by steve-o-meter  #
# Version    : 2.5 modded by nordmograph.com  #
# License    : Released under GPL             #
###############################################
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }
class getPuaTab extends cbTabHandler{
	function getPuaTab(){
		$params=$this->params;
		$this->cbTabHandler();
	}
	function getDisplayTab($tab,$user,$ui){
		// CB_framework
		global $_CB_framework,$_CB_database;
		$absolute_path = $_CB_framework->getCfg( 'absolute_path' );
		$livesite = $_CB_framework->getCfg( 'live_site' ).'/';
		$lang =$_CB_framework->getCfg( 'lang' );
		$my_id = $_CB_framework->myId();
		$database = $_CB_database;
		
		// paremeters
		$params = $this->params;
		$puaitemid = $params->get('puaitemid', '100004');
		$showrss = $params->get('showrss', 0);
		$showfav = $params->get('showfav', 1);
		
		if (!file_exists( $absolute_path.'/components/com_puarcade/puarcade.php'))
			$return = 'PUarcade is not installed';
		else{
			if(file_exists($absolute_path.'/components/com_comprofiler/plugin/user/plug_puarcadehighscoretab/lang/'.$lang.'.php'))
			  	require_once($absolute_path.'/components/com_comprofiler/plugin/user/plug_puarcadehighscoretab/lang/'.$lang.'.php');
			else
			  	require_once($absolute_path.'/components/com_comprofiler/plugin/user/plug_puarcadehighscoretab/lang/english.php');
			$limit=25;
			$return = '';
			$th = '';
			$imagepath = $livesite.'/components/images/';
			$database->setquery("Select COUNT(*) from #__puarcade where userid = '$user->id'");
			$dbrow = $database->loadRow();
			$totalscores = $dbrow[0];
			$pagingParams = $this->_getPaging(array());
			if (@$pagingParams['limitstart'] === null) $pagingParams['limitstart'] = '0';
			if (@$pagingParams['limit'] === null) $pagingParams['limit'] = $limit;
			switch ($pagingParams['sortby']) {
				case 'title':
					$database->setQuery( 'SELECT #__puarcade.score,#__puarcade.date,#__puarcade.gameid,#__puarcade_games.id,#__puarcade_games.title,#__puarcade_games.imagename,#__puarcade_games.folderid,#__puarcade_games.numplayed,#__puarcade_games.reverse_score,#__puarcade_games.imagename FROM #__puarcade left join #__puarcade_games on (#__puarcade.gameid = #__puarcade_games.id) WHERE #__puarcade.userid='.$user->id.' order by #__puarcade_games.title ASC LIMIT '.$pagingParams['limitstart'].','.$pagingParams['limit']);
					break;
				case 'date':
				default:
					$database->setQuery( 'SELECT #__puarcade.score,#__puarcade.date,#__puarcade.gameid,#__puarcade_games.id,#__puarcade_games.title,#__puarcade_games.imagename,#__puarcade_games.folderid,#__puarcade_games.numplayed,#__puarcade_games.reverse_score,#__puarcade_games.imagename FROM #__puarcade left join #__puarcade_games on (#__puarcade.gameid = #__puarcade_games.id) WHERE #__puarcade.userid='.$user->id.' order by #__puarcade.date DESC LIMIT '.$pagingParams['limitstart'].','.$pagingParams['limit']);
					break;
			}
			$scores = $database->loadObjectList();
			$th .= '<tr><th>&nbsp</th>';
			$th .= '<th width="25%">';
			$th .= $this->_writeSortByLink($pagingParams, '', 'date',_PUATAB_DATE,true);
			$th .= '</th>';
			$th .=  '<th></th>';
			$th .= '<th width=30%>';
			$th .= $this->_writeSortByLink($pagingParams, '', 'title',_PUATAB_GAME,false);
			$th .= '</th>';
			$th .= '<th>'._PUATAB_RANK.'</th>';
			$th .= '<th width=15%>';
			$th .= _PUATAB_SCORE;
			$th .= '</th>';
			if (($my_id != $user->id) && ($my_id != 0))
				$th .= '<th>'._PUATAB_YOURSCORE.'</th>';
			$th .= '</tr>';

			if($my_id != 0 && $showrss){
			//Shows link to forthcoming user own scores rss file from the dediated plugin by nordmograph.com
				$return .= "<div align='right'>";
				$return .= "<a href='".$livesite."scores_feeds/".$my_id.".xml' target='_blank'";
				$return .= "<img src='".$livesite."images/M_images/livemarks.png' alt='"._PUATAB_ADDRSS."' width='16' height='16' /> ";
				$return .= _PUATAB_ADDRSS;
				$return .= "</a>";
				$return .= "</div>";	
			}
			
			$return .= '<table cellpadding="2" cellspacing="1" align="center" width="95%">'.$th;
			$i=2;
			$j=$pagingParams['limitstart'];
			foreach ($scores as $score){
				$j++;
				if ($i == 1)
					$i = 2;
				else
					$i = 1;
				$timestamp = $score->date;
				$timestamp = @ereg_replace("[^0-9]",'',$timestamp);
				$return .='<tr class=sectiontableentry'.$i.'>';
				$return .= '<td>'.$j.'</td>';
				$return .= '<td>'.date('F j, Y g:i a',mktime(substr($timestamp,8,2),substr($timestamp,10,2),substr($timestamp,12,2),substr($timestamp,4,2),substr($timestamp,6,2),substr($timestamp,0,4))).'</td>';
				$return .= '<td>';
				$return .= '<img src="'.$livesite.'components/images/'.$score->imagename.'" alt="'.$score->title.'" width="25" height="25" />';
				$return .= '</td>';								
				$return .= '<td><a href='.cbSef('index.php?option=com_puarcade&Itemid='.$puaitemid.'&fid='.$score->folderid.'&gid='.$score->gameid).'>'.$score->title.'</a>';
				if (($faves = True) && ($user->id != 0) && $showfav) {
					$database->setQuery("SELECT gid,userid FROM #__puarcade_faves WHERE gid LIKE '$score->gameid' AND userid LIKE '$user->id'");
					$res = $database->query();
					$count = $database->getNumRows();
					if ($count > 0) {
						$return .= ' <img src="'.$livesite.'components/images/fav.gif" border="0" alt="'._PUATAB_USERSFAV.'" align="absmiddle" align="right" />';
					}
				}
				$return .= '</td>';
				$return .= '<td>';
				$database->setQuery("SELECT count(*) FROM #__puarcade WHERE gameid=".$score->gameid." AND score > ".$score->score.";");
				$rank = NULL;
				$rank=$database->loadResult() + 1;
				if ($score->reverse_score) {
					$database->setQuery("SELECT count(*) FROM #__puarcade WHERE gameid=".$score->gameid." AND score < ".$score->score.";");
					$rank = NULL;
					$rank=$database->loadResult() + 1;			
				}
				$return .= $rank;
				$return .= '</td>';				
				$return .= '<td>'.$score->score.'</td>';
				if (($my_id != $user->id) && ($my_id != 0)){
					$database->setQuery( "SELECT score,userid,gameid FROM #__puarcade WHERE userid='".strval($my_id)."' AND gameid='".strval($score->gameid)."'" );
					$myscore = $database->loadObjectList();
					$return.='<td>';
					if ($score->reverse_score) {
						if (isset($myscore[0]->score) && $myscore[0]->score > $score->score)
							$return.='<b>'.$myscore[0]->score.'</b>';
						else if (isset($myscore[0]->score) && $myscore[0]->score < $score->score)
							$return.=$myscore[0]->score;
					$return.='</td>';
					}
					else {
						if (isset($myscore[0]->score) && $myscore[0]->score < $score->score)
							$return.='<b>'.$myscore[0]->score.'</b>';
						else if (isset($myscore[0]->score) && $myscore[0]->score > $score->score)
							$return.=$myscore[0]->score;
					}
					$return.='</td>';
				}
				$return .='</tr>';
			}
			$return .= $th.'</table>';
			if ($totalscores > $pagingParams['limit']) 
				$return .= '<div style="width:95%;text-align:center;">'.$this->_writePaging($pagingParams,$pagingParams['sortby'],$pagingParams['limit'],$totalscores).'</div>';
		}
		if (count($scores) < 1) $return='';
		return $return;
	}
}
?>